#ifndef TIMEREPLICATOR_H
#define TIMEREPLICATOR_H

#include <QObject>

#include "device/DeviceBase.h"
#include "protocol/TimeReplicatorProtocolBM.h"
#include "protocol/dto/TimeReplicatorStatusDto.h"
#include "protocol/dto/CommandReplyDto.h"

class TimeReplicator : public DeviceBase
{
    Q_OBJECT
public:
    explicit TimeReplicator(QObject *parent = nullptr);
    ~TimeReplicator();

    void frameParse(QList<QByteArray> frameList);

    void mockReceivData();
    void mockReceivCmdReply();

    void afterFrameParse(DeviceFrameBaseDto * frameDto);
    void afterCommandReply(DeviceFrameBaseDto * frameDto);
    void sendDataToSerial(QByteArray data);

signals:
    void sendDataToDraw(DeviceFrameBaseDto * frameData);
    void sendCommandToDisplay(QJsonObject command);

public slots:
    void dataReceivedHandler(QByteArray data);
    void dataBReceivedHandler(QByteArray data);
    void commandReceivedHandler(QJsonObject command);

};

#endif // TIMEREPLICATOR_H
